﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim cursor1 As Cursor
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim spnFirstName As Spinner
	Dim  DOB As MaskedEditText
	Dim Names As EditText
	Dim Yeard As EditText
	Dim fname As EditText
	Dim fmobile As EditText
	Dim femail As EditText
	Dim Memail As EditText
	Dim mname As EditText
	Dim mmobile As EditText
	Dim Dialog As JavaObject

End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("applystudent")
	Activity.Title="New Student Application"
	Dim lt As Long
	DateTime.DateFormat = "dd/MM/yyyy" ' "1961-08-29"
	Dim datestring As String = DateTime.Date(JsonDateToTick( DOB.Text))
	lt = DateTime.DateParse(datestring)
	DateTime.DateFormat = "dd/MM/yyyy"
	Log(lt)
	InitSpinners

End Sub
Sub IsConnectedToInternet As Boolean
	Dim r As Reflector
 
	r.Target = r.GetContext
	r.Target = r.RunMethod2("getSystemService", "connectivity", "java.lang.String")
	r.Target = r.RunMethod("getActiveNetworkInfo")
 
	If r.Target <> Null Then
		Return r.RunMethod("isConnectedOrConnecting")
	End If
 
	Return False
End Sub
Sub JsonDateToTick(s As String) As Long
	Dim m As Matcher = Regex.Matcher("\d+", s)
	If m.Find Then
		Return m.Match
	End If
	Log("Invalid date: " & s)
	Return 0
End Sub


Sub LTrim(s As String) As String
	Dim m As Matcher = Regex.Matcher("^(\s+)", s)
	If m.Find Then
		Return s.SubString(m.GetEnd(1))
	Else
		Return s
	End If
End Sub

Sub RTrim(s As String) As String
	Dim m As Matcher = Regex.Matcher("(\s+)$", s)
	If m.Find Then
		Return s.SubString(m.GetEnd(1))
	Else
		Return s
	End If
End Sub

Sub DOB_FocusChanged(HasFocus As Boolean)
	If HasFocus Then
		Dim Test As String
            
		Test = DOB.Text
            
		Test = Test.Replace("/", "")
            
		If IsNumber(Test) Then
			'MaskedEditText2.RequestFocus
		Else

			DOB.ShowError("Invalid date")
			Return

		End If
		
	End If
End Sub

Sub InitSpinners
	Private i As Int
	Private Query1 As String
	Private Curs As Cursor
		
	Query1 = "SELECT DISTINCT Class FROM Classes ORDER BY Class ASC"
	Curs = Starter.SQL1.ExecQuery(Query1)
	'we add 'no filter' as no selection
	spnFirstName.Add("no filter")
	'we fill the Spinner with the data from the database
	For i = 0 To Curs.RowCount - 1
		Curs.Position = i
		spnFirstName.Add(Curs.GetString("Class"))
	Next
End Sub
Sub Activity_Resume
	'StartActivity(Simplechat)
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub Button1_Click
	
	If IsNotValidEmail(Memail.Text,"Email Address") = True Then
		Memail.RequestFocus
		 Return
	End If
	If IsNotValidEmail(femail.Text,"Email Address") = True Then
		femail.RequestFocus
		 Return
	End If
	
	If Names.Text="" Then
		MsgboxAsync("You Must Indicate the Student Name  ", "SMIS")
		Names.RequestFocus
	Return
	End If
	
	If spnFirstName.SelectedItem="no filter" Then
		MsgboxAsync("You Must Indicate the Class  ", "SMIS")
		spnFirstName.RequestFocus
		Return
	End If
	
	If Yeard.Text="" Then
		MsgboxAsync("You Must Indicate the Year  ", "SMIS")
		Yeard.RequestFocus
		Return
	End If
	
	If DOB.Text="__/__/____" Then
		MsgboxAsync("You Must Indicate the Date of Birth  ", "SMIS")
		'DOB.RequestFocus
		Return
	End If
	
	If IsConnectedToInternet= True Then
	
		cursor1 = Starter.SQL1.ExecQuery("SELECT phone AS Phone,Sex FROM Register")
		If cursor1.RowCount > 0 Then
			'	For i = 0 To cursor1.RowCount - 1
			cursor1.Position =0
			Dim Phoneq As String
			Phoneq = cursor1.Getstring("Phone")
			
			Dim sx As String
			sx = cursor1.Getstring("Sex")
			'Next
		End If
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download($"http://kccug.com/KabojjaApp/RecieveApplicant.ashx?n=${LTrim(RTrim(Names.Text))}&c=${spnFirstName.SelectedItem}&y=${Yeard.Text}&fn=${LTrim(RTrim(fname.Text))}&fm=${LTrim(RTrim(fmobile.Text))}&fe=${LTrim(RTrim(femail.Text))}&mn=${LTrim(RTrim(mname.Text))}&mm=${LTrim(RTrim(mmobile.Text))}&mem=${LTrim(RTrim(Memail.Text))}&dob=${LTrim(RTrim(DOB.Text))}&ty=${sx}&se=${Phoneq}"$)
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			Log(j.GetString)
		End If
		j.Release
			
		'MsgboxAsync("You have Successfully Applied Please You will be informed of the interview Date Via Our App or You Can now Pay 40000/= at School as Application Fee Thank You for Your Support","SMIS")
		ProgressDialogShow2("Processing the data...",False)
		Sleep(500)

		Dialog = Msgbox2Async("You have Successfully Applied Please You will be informed of the interview Date Via Our App .Bring with You Two PassPort Photos and a Birth Certificate to School and you will be Required to Pay 40000/= at School as Application Fee. Thank You for Your Support. Do You Want To Start A New Application ?", "New Applicants", "Yes", "Cancel", "No", Null, False)
				Wait For Msgbox_Result (Result As Int)
		Dialog = Null
		If Result = DialogResponse.POSITIVE Then
			ProgressDialogHide
			Names.Text = ""
			spnFirstName.Clear 
			Yeard.Text=""
			fname.Text=""
			fmobile.Text=""
			femail.Text=""
			mname.Text=""
			mmobile.Text=""
			Memail.Text=""
			DOB.Text=""
			Activity.LoadLayout("applystudent")
		Else
			If Result = DialogResponse.NEGATIVE Then
				ProgressDialogShow2("Processing the data...",False)
				Sleep(500)
		
				Activity.Finish
			End If
		End If

Else
	MsgboxAsync("Error Connecting to the Server Please Check Your Internet Connection","Server Error")
		Return
	End If
End Sub


Sub IsNotValidEmail(valueToCheck As String, title As String) As Boolean
	valueToCheck = valueToCheck.Trim
	Log(title)
	If IsEmail(valueToCheck)= False Then
	MsgboxAsync("Invalid Email address ", "SMIS")
		Return True
	Else
		Return False
	End If
End Sub
Sub IsEmail(EmailAddress As String) As Boolean
	If EmailAddress.Length = 0 Then Return True
	Dim MatchEmail As Matcher = Regex.Matcher("^(?i)[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])$", EmailAddress)
	If MatchEmail.Find = True Then
		Return True
	Else
		Return False
	End If
End Sub
